local function setchar(row, col, char)
	 row = tonumber(row) or 0
	 col = tonumber(col) or 0

	 local color = vt.getColor(charTable, row, col) or {255, 255 ,255, 255} -- still possible to be nil
	 local bg = vt.getBg(charTable, row, col) or {0, 0 ,0, 255 }-- still possible to be nil
	 vt.insertCharacter(charTable, row, col, char, color, bg)
end

local function setstring(row, col, str)
	 row = tonumber(row) or 0
	 col = tonumber(col) or 0
	 str = parse.replaceUnderscores(str)

	 local color = vt.getColor(charTable, row, col) or {255, 255 ,255, 255} -- still possible to be nil
	 local bg = vt.getBg(charTable, row, col) or {0, 0 ,0, 255 }-- still possible to be nil
	 vt.insertString(charTable, row, col, str, color, bg)
end

local function setcolor(row, col, r, g, b, a)
	 row = tonumber(row) or 0
	 col = tonumber(col) or 0
	 r = tonumber(r)
	 g = tonumber(g)
	 b = tonumber(b)
	 a = tonumber(a)

	 local bg = vt.getBg(charTable, row, col) or {0, 0 ,0, 255} -- still possible to be nil
	 local char = vt.getChar(charTable, row, col) or " " -- still possible to be nil
	 vt.insertCharacter(charTable, row, col, char, {r, g, b, a}, bg)
end

local function setbg(row, col, r, g, b, a)
	 row = tonumber(row) or 0
	 col = tonumber(col) or 0
	 r = tonumber(r)
	 g = tonumber(g)
	 b = tonumber(b)
	 a = tonumber(a)

	 local color = vt.getColor(charTable, row, col) or {255, 255 ,255, 255} -- still possible to be nil
	 local char = vt.getChar(charTable, row, col) or " " -- still possible to be nil
	 vt.insertCharacter(charTable, row, col, char, color, {r, g, b, a})
end

local function setrow(row, char, r, g, b, a, r2, g2, b2, a2)
	 row = tonumber(row) or 0
	 r = tonumber(r) or 255
	 g = tonumber(g) or 255
	 b = tonumber(b) or 255
	 a = tonumber(a) or 255
	 r2 = tonumber(r2) or 0
	 g2 = tonumber(g2) or 0
	 b2 = tonumber(b2) or 0
	 a2 = tonumber(a2) or 255

	 vt.setRow(charTable, row, char, {r, g, b, a}, {r2, g2, b2, a2})
end

local function setcol(row, char, r, g, b, a, r2, g2, b2, a2)
	 row = tonumber(row) or 0
	 r = tonumber(r) or 255
	 g = tonumber(g) or 255
	 b = tonumber(b) or 255
	 a = tonumber(a) or 255
	 r2 = tonumber(r2) or 0
	 g2 = tonumber(g2) or 0
	 b2 = tonumber(b2) or 0
	 a2 = tonumber(a2) or 255

	 vt.setCol(charTable, row, char, {r, g, b, a}, {r2, g2, b2, a2})
end

local function clearrow(row)
	 row = tonumber(row) or 0

	 vt.setRow(charTable, row, " ", {255, 255, 255, 255}, {0, 0, 0, 0})
end

-- Commands using anonymous functions
cmd.register("setch", function(row, col, char) setchar(row, col, char) end)
cmd.register("setst", function(row, col, str) setstring(row, col, str) end)
cmd.register("setbg", function(row, col, r, g, b, a) setbg(row, col, r, g, b, a) end)
cmd.register("setcl", function(row, col, r, g, b, a) setcolor(row, col, r, g, b, a) end)
cmd.register("setrow", function(row, char, r, g, b, a, r2, g2, b2, a2)
								setrow(row, char, r, g, b, a, r2, g2, b2, a2) end)
cmd.register("setcol", function(col, char, r, g, b, a, r2, g2, b2, a2)
								setcol(col, char, r, g, b, a, r2, g2, b2, a2) end)
cmd.register("clear", function() vt.clear(charTable)  end)
cmd.register("clearrow", function(row) clearrow(row) end)
cmd.register("shiftl", function() vt.shiftLinesDown(charTable) end)
