local config = {}

function config.load(filePath)
    local file = io.open(filePath, "r")

    if not file then
        print("Error: Unable to open file " .. filePath)
        return nil
    end

    local fileContent = file:read("*a")
    file:close()

    local chunk, errorMessage = loadstring(fileContent, "config")

    if not chunk then
        print("Error loading configuration: " .. errorMessage)
        return nil
    end

    local success, config = pcall(chunk)

    if not success then
        print("Error executing configuration: " .. config)
        return nil
    end

    return config
end

return config
