local parse = {}

-- note: when there is no closing tag there is an error that propagates through the whole file

function parse.text(input)
	 -- Define the pattern to match text starting with '^' and ending with '.'
	 local pattern = "%^(.-)%^"

	 -- Use string.gmatch to iterate over all matches in the input text
	 local matches = {}
	 for match in string.gmatch(input, pattern) do
			table.insert(matches, match)
	 end

	 -- Check if any matches were found
	 if #matches > 0 then
			return matches
	 else
			return {"No match found"}
	 end
end

function parse.words(input)
	 -- Use string.gmatch to iterate over words separated by spaces
	 local words = {}
	 for word in string.gmatch(input, "%S+") do
			table.insert(words, word)
	 end

	 return words
end

function parse.replaceUnderscores(input)
	 -- Replace underscores with whitespace, except for underscores starting with %
	 local str = string.gsub(input, "([^%%_])_", "%1 ")
	 str = string.gsub(str, "%%_", "_")
	 return str
end

return parse
