--h       = require "lib.helper"
vt      = require "lib.vt2000"
cmd     = require "lib.commands"
events  = require "lib.events"
config  = require "lib.config"
parse   = require "lib.parser"
socket  = require "socket"
require "commands"

-- load config
configFile = "config.lua"
config = config.load(configFile)
--print("shell:", config.shell)

-- Initialize rows and columns
rows = 0
cols = 0

-- Table to store characters
charTable = {}

-- Specify font size and font (have to be globals)
fontSize = config.fontSize
font = love.graphics.newFont(config.font,fontSize)

-- Populates chartable with random character, background and color
-- function populateCharacterTable(r, c)
-- 	 charTable = {}

-- 	 for i = 1, r do
-- 			charTable[i] = {}
-- 			for j = 1, c do
-- 				 if j == c then
-- 						charTable[i][j] = { " ", nil } -- Use default color if nil
-- 				 else
-- 						-- Example: Use a random uppercase letter and a random color
-- 						local char = string.char(math.random(65, 90)) -- Random uppercase letter (ASCII 65-90)
-- 						local color = { math.random(0, 255), math.random(0, 255), math.random(0, 255), 255 }
-- 						local bg = { math.random(0, 255), math.random(0, 255), math.random(0, 255), 255 }
-- 						charTable[i][j] = { char, color, bg }
-- 				 end
-- 			end
-- 	 end
-- end

function love.load()
	 -- This function is called once at the beginning

	 -- Set the window title
	 love.window.setTitle("Terminal")

	 -- Set the window dimensions
	 love.window.setMode(800, 600, {resizable = true})

	 -- Set the font
	 love.graphics.setFont(font)

	 -- shell connection
	 os.execute(config.shell)
	 udp = socket.udp()
	 udp:setsockname("*", 12345)  -- Bind to all available interfaces on port 12345
	 udp:settimeout(0)  -- Non-blocking
	 data, ip, port = "", "", 0

	 -- keybinds
	  keybinds =  {
				 ["escape"] = { action = quit, eventType = "press" },
			   ["mouse2"] = { action = quit, eventType = "release" },
	 }

	 -- Set keybindings
	events.add(udp, ip, port, keybinds)

	 -- Update the grid based on the new window size
	 rows, cols = vt.updateGrid(font)

end

function quit()
	 os.execute("kill -9 `cat /tmp/messages.pid`")
	 love.event.quit()
end

function love.update()
	 -- Update game logic here

	  data, ip, port = udp:receivefrom()
    -- if data then
    --     print("Received: " .. data .. " from " .. ip .. ":" .. port)
    -- end

		if data  then
			 events.add(udp, ip, port, keybinds)

			 -- Parse text using parse.text
			local parsedText = parse.text(data)

			for i=1 , #parsedText, 1 do
				 local words = parse.words(parsedText[i])

				 cmd.exec(unpack(words))
			end

		end

		-- makes the program to slow
		--socket.sleep(0.01)

		--populateCharacterTable(rows, cols)
end

function love.draw()

	 --love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)

   -- Draw grid
	 vt.drawGrid(charTable, font, cols, rows)
end
