-- main.lua

local keymap = require("keymap")

function love.load()
  keymap.add {
    ["ctrl+q"] = { action = core_quit, eventType = "press" },
    ["ctrl+shift+a"] = { action = core_select_all, eventType = "press" },
    ["ctrl+r"] = { action = core_reload, eventType = "release" },
    ["mouse1"] = { action = mouse_click, eventType = "press" },
    ["mouse3"] = { action = mouse_right_click, eventType = "press" },
    ["mouse2"] = { action = mouse_middle_click, eventType = "release" }
  }
end

function core_quit()
  love.event.quit()
end

function core_select_all()
  print("Selecting all...")
end

function core_reload()
  print("Reload triggered...")
end

function mouse_click()
  print("Left mouse button clicked")
end

function mouse_right_click()
  print("Right mouse button clicked")
end

function mouse_middle_click()
  print("Middle mouse button released")
end
