-- main.lua (Server)

local socket = require("socket")

function love.load()
	 udp = socket.udp()
	 udp:setsockname("*", 12345)  -- Bind to all available interfaces on port 12345
	 udp:settimeout(0)  -- Non-blocking
	 data, ip, port = "", "", 0
end


love.textinput = function(text)
	 udp:sendto("textinput: " ..  text, ip, port)
	 print(text)
end

function love.update(dt)
	 data, ip, port = udp:receivefrom()
	 if data then
			print("Received: " .. data .. " from " .. ip .. ":" .. port)
			-- Echo back the received data to the client
			udp:sendto("Server: " .. data, ip, port)
	 end
end

function love.draw()
	 love.graphics.print("Server", 10, 10)
end
