local socket = require("socket")

-- Set server address and port
local serverAddress = "127.0.0.1"
local serverPort = "12345"

-- Create a UDP socket
local udp = assert(socket.udp())
udp:setpeername(serverAddress, serverPort)
udp:settimeout(0)  -- Non-blocking

-- Data to send to the server
local dataToSend = "^Info messages.lua"

-- Send data to the server
udp:send(dataToSend)

-- pattern for matching
local pattern = "(%w+):%s+(%w+)"

while true do
	 -- Receive data from the server
	 local receivedData, err = udp:receive()

	 -- Check if data was received
	 if receivedData then
			for field, text in receivedData:gmatch(pattern) do
				 --print("text:", field, text)

				 -- Send data to the servere
				 udp:send("^shiftl^ ^setst 1 1 " .. field .. ":" .. text .. "^")
			end
	 elseif err ~= "timeout" then
			print("Error receiving data: " .. (err or "unknown error"))
	 end

	 socket.sleep(0.01)

end
