local h = require "helper"

function parseText(input)
  -- Define the pattern to match text starting with '^' and ending with '.'
  local pattern = "%^(.-)%^"

  -- Use string.gmatch to iterate over all matches in the input text
  local matches = {}
  for match in string.gmatch(input, pattern) do
    table.insert(matches, match)
  end

  -- Check if any matches were found
  if #matches > 0 then
    return matches
  else
    return {"No match found"}
  end
end

function parseWords(input)
  -- Use string.gmatch to iterate over words separated by spaces
  local words = {}
  for word in string.gmatch(input, "%S+") do
    table.insert(words, word)
  end

  return words
end

-- Example usage:
local inputText = "^setbg 1 1 a^  ^parse^  ^example text^."

-- Parse text using parseText function
local parsedText = parseText(inputText)
print(h.dump(parsedText))
print("")
-- print("Parsed Text:")
-- for _, match in ipairs(parsedText) do
--   print(match)
-- end

-- Call parseWords with each match from parseText and print the result
--print("Parsed Words:")
-- for _, match in ipairs(parsedText) do
--   local parsedWords = parseWords(match)
--   for i, word in ipairs(parsedWords) do
--     print("parse word n: ".. i .. " of ".. #word .. " " .. word)
--   end
-- end

for i=1 , #parsedText, 1 do
	 local words = parseWords(parsedText[i])
	 print(h.dump(words))
end
